<?php
namespace Teknisa\CADEXP\Services;

use Zeedhi\Framework\DataSource\FilterCriteria;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
//use Teknisa\Model\Geral\Entities\Transport;
use Teknisa\Model\Geral\Entities\Parceria;
use Teknisa\Model\Geral\Entities\Parcnegocio;
use Teknisa\Model\Geral\Entities\Enderecoparc;

class Ger01100TransportadoraService{

	protected $environment;
	protected $dataSourceManager;
	protected $newCode;

	public function __construct(Environment $environment, \Doctrine\ORM\EntityManager $entityManager ,$dataSourceManager,NewCode $newCode){
		$this->environment = $environment;
        $this->entityManager = $entityManager;
		$this->dataSourceManager = $dataSourceManager;
        $this->newCode = $newCode;
	}

	public function buscar($condicao){
		return $this->dataSourceManager->findBy($condicao);
	}

	public function deletar($dataSet){
    	$this->dataSourceManager->delete($dataSet);
	}

	public function geraNovoCodigo($tableName, $nrorg){
		return $this->newCode->getCodeByTableName($tableName, $nrorg);
	}

	public function salvar($rows){
		try {
			$connection = $this->entityManager->getConnection();
	        $connection->beginTransaction();

			$codigoParceiro = $this->salvarParceiro($rows);
			$this->salvarParceria($rows,$codigoParceiro);
			$this->salvarTransportadora($rows,$codigoParceiro);

			$connection->commit();
		}catch (\Exception $e) {

    		$this->entityManager->rollback();
        	throw $e;
        }
	}

	public function salvarParceiro($rows){
        try {
           	$conditions = $this->condicaoParceiro($rows);
            $resultadoBanco = $this->realizaConsultaBanco($conditions,'parcnegocio');
            if(empty($resultadoBanco->getRows())){
                $nrorg = $this->environment->getNrorgTrab();
        		$operador = $this->environment->getCdOperador();
        		$currentTime = $this->environment->getCurrentTime();
                $novoCodigoParceiro = $this->geraNovoCodigo('PARCNEGOCIO',$this->environment->getNrOrgTrab());
                $parcnegocio = new Parcnegocio();
				$parcnegocio->setNrorg($nrorg);
	            $parcnegocio->setDtinclusao($currentTime);
	            $parcnegocio->setCdoperinclusao($operador);
	            $parcnegocio->setNrorginclusao($nrorg);
	            $parcnegocio->setNrparcnegocio($novoCodigoParceiro);
	            $parcnegocio->setNrinscricaoparc($rows['NRINSJURTRAN']);
	            $parcnegocio->setNmprincipalparc($rows['NMRAZSOCTRAN']);
   	            $parcnegocio->setNmsecundariparc($rows['NMFANTTRAN']);
   	            $parcnegocio->setCdtipoparcprincipal('TRANSPORTADORA');
   	            //$parcnegocio->setIdparcfundido('N');
   	            $this->entityManager->persist($parcnegocio);
            	$this->entityManager->flush();
            	$this->inserirEnderecoParceiro($rows,$novoCodigoParceiro);
                return $novoCodigoParceiro;
            }
            else{
                $codigoParceiro= $resultadoBanco->getRows()[0]['NRPARCNEGOCIO'];
                return $codigoParceiro;
            }
        }catch (\Exception $e) {
           	throw $e;
        }
    }

    public function salvarTransportadora ($row,$codigoParceiro){
    	try {
    		$nrorg = $this->environment->getNrorgTrab();
        	$operador = $this->environment->getCdOperador();
        	$currentTime = $this->environment->getCurrentTime();
    		$row->set('NRPARCNEGOCIO',$codigoParceiro);
            $row->set('NRORG',$nrorg);
            $row->set('DTINCLUSAO',$currentTime);
            $row->set('CDOPERINCLUSAO',$operador);
            $row->set('NRORGINCLUSAO',$nrorg);
            $row->set('IDATIVO','S');
            $array[] = $row;
            $dataSet = new DataSet('transport_completa', $array);

            /*$trasport = new Transport();
    		$trasport->setNmrazsoctran($row['NMRAZSOCTRAN']);
            $trasport->setNrinsjurtran($row['NRINSJURTRAN']);
    		$trasport->setNmfanttran($row['NMFANTTRAN']);
       		$trasport->setIdtpijurtran($row['IDTPIJURTRAN']);
	   		$trasport->setNrinsesttran($row['NRINSESTTRAN']);
    		$trasport->setDsendetran($row['DSENDETRAN']);
    		$trasport->setNmbairtran($row['NMBAIRTRAN']);
    		$trasport->setNrceptran($row['NRCEPTRAN']);
    		$trasport->setNrteletran($row['NRTELETRAN']);
	   		$trasport->setNrramaltran($row['NRRAMALTRAN']);
    		$trasport->setNrtelextran($row['NRTELEXTRAN']);
    		$trasport->setNrfaxtran($row['NRFAXTRAN']);
    		$trasport->setCdforneced($row['CDFORNECED']);
    		$trasport->setNmconttran($row['NMCONTTRAN']);
    		$trasport->setDsemailtran($row['DSEMAILTRAN']);
    		$trasport->setCdpais($row['CDPAIS']);
    		$trasport->setSgestado($row['SGESTADO']);
    		$trasport->setCdmunicipio($row['CDMUNICIPIO']);
    		$trasport->setCdtiptrans($row['CDTIPTRANS']);
    		$trasport->setDsemailtranspnfe($row['DSEMAILTRANSPNFE']);
    		$trasport->setIdcomparqxmltra($row['IDCOMPARQXMLTRA']);
    		$trasport->setCdveicpadrao($row['CDVEICPADRAO']);
    		$trasport->setNrrntrc($row['NRRNTRC']);
    		$trasport->setNrciot($row['NRCIOT']);
            $this->entityManager->persist($dataSet);
            */

            $this->dataSourceManager->persist($dataSet);
            $this->entityManager->flush();
    	}catch (\Exception $e) {
           	throw $e;
        }
    }

    public function inserirEnderecoParceiro($row,$codigoParceiro){
    	try {
	    	$nrorg = $this->environment->getNrorgTrab();
			$operador = $this->environment->getCdOperador();
			$currentTime = $this->environment->getCurrentTime();
	        $novoCodigoEndereco = $this->geraNovoCodigo('ENDERECOPARC',$this->environment->getNrOrgTrab());
	        $enderecoparc = new Enderecoparc();
			$enderecoparc->setNrorg($nrorg);
	        $enderecoparc->setDtinclusao($currentTime);
	        $enderecoparc->setCdoperinclusao($operador);
	        $enderecoparc->setNrorginclusao($nrorg);
	        $enderecoparc->setNrparcnegocio($codigoParceiro);
	        $enderecoparc->setNrenderecoparc($novoCodigoEndereco);
			$enderecoparc->setCdtipoendereco('PRINCIPAL');
			$enderecoparc->setCdlogradouro($row['CDLOGRADOURO']);
	        $enderecoparc->setCdbairro($row['CDBAIRRO']);
		    $enderecoparc->setCdMunicipio($row['CDMUNICIPIO']);
	  	    $enderecoparc->setSgestado($row['SGESTADO']);
	  	    $enderecoparc->setCdpais($row['CDPAIS']);
	  	    $enderecoparc->setNmbairroendereco($row['NMBAIRTRAN']);
	  	    $enderecoparc->setNrcependereco($row['NRCEPTRAN']);
	  	    $enderecoparc->setDsendereco($row['DSENDETRAN']);
	        $this->entityManager->persist($enderecoparc);
	    	$this->entityManager->flush();
		}catch (\Exception $e) {
           	throw $e;
        }
	}

	public function salvarParceria($row, $codigoParceiro){
		try{
			$conditions = $this->condicaoParceria($codigoParceiro);
            $resultadoBanco = $this->realizaConsultaBanco($conditions,'parceria');
            if(empty($resultadoBanco->getRows())){
                $nrorg = $this->environment->getNrorgTrab();
                $operador = $this->environment->getCdOperador();
                $currentTime = $this->environment->getCurrentTime();
                $novoCodigoParceria = $this->geraNovoCodigo('PARCERIA',$this->environment->getNrOrgTrab());
                $parceria = new Parceria();
                $parceria->setNrparcnegocio($codigoParceiro);
                $parceria->setNrparceria($novoCodigoParceria);
                $parceria->setCdtipoparceiro('TRANSPORTADORA');
                $parceria->setNrorg($nrorg);
                $parceria->setDtinclusao($currentTime);
                $parceria->setCdoperinclusao($operador);
                $parceria->setNrorginclusao($nrorg);
                $parceria->setIdativo("S");
                $this->entityManager->persist($parceria);
                $this->entityManager->flush();
            }

        }catch (\Exception $e) {
       		throw $e;
        }
	}

    public function condicaoParceiro($row) {
        $conditions = array(
          array(
            "value" => $this->environment->getNrOrgTrab(),
            "operator" => "=",
            "columnName" => "NRORG"
          ),
          array(
            "value" => $row['NRINSJURTRAN'],
            "operator" => "=",
            "columnName" => "NRINSCRICAOPARC"
          )
        );
        return $conditions;
    }

    public function condicaoParceria($codigoParceiro) {
        $conditions = array(
          array(
            "value" => $this->environment->getNrOrgTrab(),
            "operator" => "=",
            "columnName" => "NRORG"
          ),
          array(
            "value" => $codigoParceiro,
            "operator" => "=",
            "columnName" => "NRPARCNEGOCIO"
          ),
          array(
            "value" => 'TRANSPORTADORA',
            "operator" => "=",
            "columnName" => "CDTIPOPARCEIRO"
          )
        );
        return $conditions;
    }

	public function realizaConsultaBanco($conditions,$dataSourceName) {
        $filterCriteria = new FilterCriteria($dataSourceName,$conditions);
        //$newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
        $dataSet = $this->buscar($filterCriteria);
        return $dataSet;
    }

}